3 # Copyright (c) 2005, 2006 Junio C Hamano
8 git am [options] [<mbox>|<Maildir>...]
9 git am [options] (--resolved | --skip | --abort)
11 i,interactive run interactively
12 b,binary* (historical option -- no-op)
13 3,3way allow fall back on 3way merging if needed
14 s,signoff add a Signed-off-by line to the commit message
15 u,utf8 recode into utf8 (default)
16 k,keep pass -k flag to git-mailinfo
17 whitespace= pass it through git-apply
18 directory= pass it through git-apply
19 C= pass it through git-apply
20 p= pass it through git-apply
21 patch-format= format the patch(es) are in
22 reject pass it through git-apply
23 resolvemsg= override error message when patch failure occurs
24 r,resolved to be used after a patch failure
25 skip skip the current patch
26 abort restore the original branch and abort the patching operation.
27 committer-date-is-author-date lie about committer date
28 ignore-date use current timestamp for author date
29 rebasing* (internal use for git-rebase)"
32 prefix
=$
(git rev-parse
--show-prefix)
37 git var GIT_COMMITTER_IDENT
>/dev
/null ||
38 die
"You need to set your committer info first"
40 if git rev-parse
--verify -q HEAD
>/dev
/null
48 git rev-parse
--sq-quote "$@"
52 echo "$1" >"$dotest/next"
56 stop_here_user_resolve
() {
57 if [ -n "$resolvemsg" ]; then
58 printf '%s\n' "$resolvemsg"
62 if test '' != "$interactive"
66 if test '' != "$threeway"
70 echo "When you have resolved this problem run \"$cmdline --resolved\"."
71 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
72 echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
78 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
79 "$dotest/patch" "$dotest/info"
80 echo "$next" >"$dotest/next"
86 echo "Cannot fall back to three-way merge."
91 O_OBJECT
=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
93 rm -fr "$dotest"/patch-merge-
*
94 mkdir
"$dotest/patch-merge-tmp-dir"
96 # First see if the patch records the index info that we can use.
97 git apply
--build-fake-ancestor "$dotest/patch-merge-tmp-index" \
99 GIT_INDEX_FILE
="$dotest/patch-merge-tmp-index" \
100 git write-tree
>"$dotest/patch-merge-base+" ||
101 cannot_fallback
"Repository lacks necessary blobs to fall back on 3-way merge."
103 echo Using index info to reconstruct a base tree...
104 if GIT_INDEX_FILE
="$dotest/patch-merge-tmp-index" \
105 git apply
--cached <"$dotest/patch"
107 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
108 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
110 cannot_fallback
"Did you hand edit your patch?
111 It does not apply to blobs recorded in its index."
114 test -f "$dotest/patch-merge-index" &&
115 his_tree
=$
(GIT_INDEX_FILE
="$dotest/patch-merge-index" git write-tree
) &&
116 orig_tree
=$
(cat "$dotest/patch-merge-base") &&
117 rm -fr "$dotest"/patch-merge-
* ||
exit 1
119 echo Falling back to patching base and
3-way merge...
121 # This is not so wrong. Depending on which base we picked,
122 # orig_tree may be wildly different from ours, but his_tree
123 # has the same set of wildly different changes in parts the
124 # patch did not touch, so recursive ends up canceling them,
125 # saying that we reverted all those changes.
127 eval GITHEAD_
$his_tree='"$FIRSTLINE"'
128 export GITHEAD_
$his_tree
129 git-merge-recursive
$orig_tree -- HEAD
$his_tree ||
{
131 echo Failed to merge
in the changes.
134 unset GITHEAD_
$his_tree
138 test $# = 0 ||
echo >&2 "$@"
145 check_patch_format
() {
146 # early return if patch_format was set from the command line
147 if test -n "$patch_format"
152 # we default to mbox format if input is from stdin and for
154 if test $# = 0 ||
test "x$1" = "x-" ||
test -d "$1"
160 # otherwise, check the first few lines of the first patch to try
161 # to detect its format
167 "From "* |
"From: "*)
170 '# This series applies on GIT commit'*)
171 patch_format
=stgit-series
173 "# HG changeset patch")
177 # if the second line is empty and the third is
178 # a From, Author or Date entry, this is very
179 # likely an StGIT patch
181 ,"From: "* |
,"Author: "* |
,"Date: "*)
189 } < "$1" || clean_abort
193 case "$patch_format" in
195 git mailsplit
-d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||
201 clean_abort
"Only one StGIT patch series can be applied at once"
203 series_dir
=`dirname "$1"`
210 set "$@" "$series_dir/$filename"
212 # remove the safety x
214 # remove the arg coming from the first-line comment
216 } < "$series_file" || clean_abort
217 # set the patch format appropriately
219 # now handle the actual StGIT patches
226 this
=`expr "$this" + 1`
227 msgnum
=`printf "%0${prec}d" $this`
228 # Perl version of StGIT parse_patch. The first nonemptyline
229 # not starting with Author, From or Date is the
230 # subject, and the body starts with the next nonempty
231 # line not starting with Author, From or Date
232 perl
-ne 'BEGIN { $subject = 0 }
233 if ($subject > 1) { print ; }
234 elsif (/^\s+$/) { next ; }
235 elsif (/^Author:/) { print s/Author/From/ ; }
236 elsif (/^(From|Date)/) { print ; }
242 print "Subject: ", $_ ;
245 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
247 echo "$this" > "$dotest/last"
252 clean_abort
"Patch format $patch_format is not supported."
258 dotest
="$GIT_DIR/rebase-apply"
259 sign
= utf8
=t keep
= skip
= interactive
= resolved
= rebasing
= abort
=
262 committer_date_is_author_date
=
277 utf8
=t
;; # this is now default
289 rebasing
=t threeway
=t keep
=t
;;
291 die
"-d option is no longer supported. Do not use."
294 shift; resolvemsg
=$1 ;;
295 --whitespace|
--directory)
296 git_apply_opt
="$git_apply_opt $(sq "$1=$2")"; shift ;;
298 git_apply_opt
="$git_apply_opt $(sq "$1$2")"; shift ;;
300 shift ; patch_format
="$1" ;;
302 git_apply_opt
="$git_apply_opt $1" ;;
303 --committer-date-is-author-date)
304 committer_date_is_author_date
=t
;;
315 # If the dotest directory exists, but we have finished applying all the
316 # patches in them, clear it out.
317 if test -d "$dotest" &&
318 last
=$
(cat "$dotest/last") &&
319 next
=$
(cat "$dotest/next") &&
321 test "$next" -gt "$last"
328 case "$#,$skip$resolved$abort" in
330 # Explicit resume command and we do not have file, so
334 # No file input but without resume parameters; catch
335 # user error to feed us a patch from standard input
336 # when there is already $dotest. This is somewhat
337 # unreliable -- stdin could be /dev/null for example
338 # and the caller did not intend to feed us a patch but
339 # wanted to continue unattended.
346 die
"previous rebase directory $dotest still exists but mbox given."
349 case "$skip,$abort" in
351 die
"Please make up your mind. --skip or --abort?"
355 git read-tree
--reset -u HEAD HEAD
356 orig_head
=$
(cat "$GIT_DIR/ORIG_HEAD")
358 git update-ref ORIG_HEAD
$orig_head
361 if test -f "$dotest/rebasing"
363 exec git rebase
--abort
366 test -f "$dotest/dirtyindex" ||
{
367 git read-tree
--reset -u HEAD ORIG_HEAD
373 rm -f "$dotest/dirtyindex"
375 # Make sure we are not given --skip, --resolved, nor --abort
376 test "$skip$resolved$abort" = "" ||
377 die
"Resolve operation not in progress, we are not resuming."
380 mkdir
-p "$dotest" ||
exit
382 if test -n "$prefix" && test $# != 0
387 test -n "$first" && {
395 set "$@" "$prefix$arg" ;;
401 check_patch_format
"$@"
405 # -s, -u, -k, --whitespace, -3, -C and -p flags are kept
406 # for the resuming session after a patch failure.
407 # -i can and must be given when resuming.
408 echo " $git_apply_opt" >"$dotest/apply-opt"
409 echo "$threeway" >"$dotest/threeway"
410 echo "$sign" >"$dotest/sign"
411 echo "$utf8" >"$dotest/utf8"
412 echo "$keep" >"$dotest/keep"
413 echo 1 >"$dotest/next"
414 if test -n "$rebasing"
416 : >"$dotest/rebasing"
418 : >"$dotest/applying"
419 if test -n "$HAS_HEAD"
421 git update-ref ORIG_HEAD HEAD
423 git update-ref
-d ORIG_HEAD
>/dev
/null
2>&1
432 files
=$
(git ls-files
) ;;
434 files
=$
(git diff-index
--cached --name-only HEAD
--) ;;
438 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
439 die
"Dirty index: cannot apply patches (dirty: $files)"
443 if test "$(cat "$dotest/utf8
")" = t
449 if test "$(cat "$dotest/keep
")" = t
453 if test "$(cat "$dotest/threeway
")" = t
457 git_apply_opt
=$
(cat "$dotest/apply-opt")
458 if test "$(cat "$dotest/sign
")" = t
460 SIGNOFF
=`git var GIT_COMMITTER_IDENT | sed -e '
462 s/^/Signed-off-by: /'
468 last
=`cat "$dotest/last"`
469 this
=`cat "$dotest/next"`
472 this
=`expr "$this" + 1`
476 if test "$this" -gt "$last"
483 while test "$this" -le "$last"
485 msgnum
=`printf "%0${prec}d" $this`
486 next
=`expr "$this" + 1`
487 test -f "$dotest/$msgnum" ||
{
493 # If we are not resuming, parse and extract the patch information
494 # into separate files:
495 # - info records the authorship and title
496 # - msg is the rest of commit log message
497 # - patch is the patch body.
499 # When we are resuming, these files are either already prepared
500 # by the user, or the user can tell us to do so by --resolved flag.
503 git mailinfo
$keep $utf8 "$dotest/msg" "$dotest/patch" \
504 <"$dotest/$msgnum" >"$dotest/info" ||
507 # skip pine's internal folder data
508 grep '^Author: Mail System Internal Data$' \
509 <"$dotest"/info
>/dev
/null
&&
512 test -s "$dotest/patch" ||
{
513 echo "Patch is empty. Was it split wrong?"
516 if test -f "$dotest/rebasing" &&
517 commit
=$
(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
518 -e q
"$dotest/$msgnum") &&
519 test "$(git cat-file -t "$commit")" = commit
521 git cat-file commit
"$commit" |
522 sed -e '1,/^$/d' >"$dotest/msg-clean"
524 SUBJECT
="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info
")"
525 case "$keep_subject" in -k) SUBJECT
="[PATCH] $SUBJECT" ;; esac
527 (printf '%s\n\n' "$SUBJECT"; cat "$dotest/msg") |
528 git stripspace
> "$dotest/msg-clean"
533 GIT_AUTHOR_NAME
="$(sed -n '/^Author/ s/Author: //p' "$dotest/info
")"
534 GIT_AUTHOR_EMAIL
="$(sed -n '/^Email/ s/Email: //p' "$dotest/info
")"
535 GIT_AUTHOR_DATE
="$(sed -n '/^Date/ s/Date: //p' "$dotest/info
")"
537 if test -z "$GIT_AUTHOR_EMAIL"
539 echo "Patch does not have a valid e-mail address."
543 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
547 if test '' != "$SIGNOFF"
550 sed -ne '/^Signed-off-by: /p' \
551 "$dotest/msg-clean" |
555 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
556 test '' = "$LAST_SIGNED_OFF_BY" && echo
563 if test -s "$dotest/msg-clean"
565 cat "$dotest/msg-clean"
567 if test '' != "$ADD_SIGNOFF"
571 } >"$dotest/final-commit"
574 case "$resolved$interactive" in
576 # This is used only for interactive view option.
577 git diff-index
-p --cached HEAD
-- >"$dotest/patch"
583 if test "$interactive" = t
586 die
"cannot be interactive without stdin connected to a terminal."
588 while test "$action" = again
590 echo "Commit Body is:"
591 echo "--------------------------"
592 cat "$dotest/final-commit"
593 echo "--------------------------"
594 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
598 [aA
]*) action
=yes interactive
= ;;
599 [nN
]*) action
=skip
;;
600 [eE
]*) git_editor
"$dotest/final-commit"
603 LESS
=-S ${PAGER:-less} "$dotest/patch" ;;
610 FIRSTLINE
=$
(sed 1q
"$dotest/final-commit")
612 if test $action = skip
618 if test -x "$GIT_DIR"/hooks
/applypatch-msg
620 "$GIT_DIR"/hooks
/applypatch-msg
"$dotest/final-commit" ||
624 printf 'Applying: %s\n' "$FIRSTLINE"
628 eval 'git apply '"$git_apply_opt"' --index "$dotest/patch"'
632 # Resolved means the user did all the hard work, and
633 # we do not have to do any patch application. Just
634 # trust what the user has in the index file and the
637 git diff-index
--quiet --cached HEAD
-- && {
638 echo "No changes - did you forget to use 'git add'?"
639 stop_here_user_resolve
$this
641 unmerged
=$
(git ls-files
-u)
642 if test -n "$unmerged"
644 echo "You still have unmerged paths in your index"
645 echo "did you forget to use 'git add'?"
646 stop_here_user_resolve
$this
653 if test $apply_status = 1 && test "$threeway" = t
657 # Applying the patch to an earlier tree and merging the
658 # result may have produced the same tree as ours.
659 git diff-index
--quiet --cached HEAD
-- && {
660 echo No changes
-- Patch already applied.
664 # clear apply_status -- we have successfully merged.
668 if test $apply_status != 0
670 printf 'Patch failed at %s %s\n' "$msgnum" "$FIRSTLINE"
671 stop_here_user_resolve
$this
674 if test -x "$GIT_DIR"/hooks
/pre-applypatch
676 "$GIT_DIR"/hooks
/pre-applypatch || stop_here
$this
679 tree
=$
(git write-tree
) &&
681 if test -n "$ignore_date"
685 parent
=$
(git rev-parse
--verify -q HEAD
) ||
686 echo >&2 "applying to an empty history"
688 if test -n "$committer_date_is_author_date"
690 GIT_COMMITTER_DATE
="$GIT_AUTHOR_DATE"
691 export GIT_COMMITTER_DATE
693 git commit-tree
$tree ${parent:+-p} $parent <"$dotest/final-commit"
695 git update-ref
-m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD
$commit $parent ||
698 if test -x "$GIT_DIR"/hooks
/post-applypatch
700 "$GIT_DIR"/hooks
/post-applypatch